package com.twomee.appear2meedemo;

import android.app.ActivityManager;
import android.app.Application;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.widget.Toast;

import com.twomee.appear2mee.Appear2mee;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

public class Appear2meeApplication extends Application implements Appear2mee.ResponseListenerCallback {
    static final String APPEAR2MEE_CLIENT_ID  = "d48bc05e-e727-4274-858a-f4f7fe3a687d6c445333-bac9-4ab0-a0b6-cc6838902abb";
    static final String APPEAR2MEE_SECRET_KEY = "60dfb9140d1845b2a29dd1bbd4109e66";

    @Override
    public void onCreate() {
        super.onCreate();
        Appear2mee.getMessage("Welcome Message", new Appear2mee.MessageReadyListener() {
            @Override
            public void ready(String name, Bundle item) {
                Log.i("App","Return Ready:" + name);
                if(item == null) return;
                Log.i("App","Message Ready:" + name);
                Appear2mee.displayMessage(item,name);
            }
        });
        Appear2mee.init(this,APPEAR2MEE_CLIENT_ID, APPEAR2MEE_SECRET_KEY);
        //optional  setupDefaults();
    }

    private static void setupDefaults() {
        // These are the built-in defaults.
        // Defaults are merged so this is no need to include any you have not changed.
        Map<String,String> overrideDefaultSettings = new HashMap<>();
        overrideDefaultSettings.put(Appear2mee.kNotificationDismiss,"Dismiss");
        overrideDefaultSettings.put(Appear2mee.kNotificationAccept,"OK");
        overrideDefaultSettings.put(Appear2mee.kMessageExpired,"Sorry, opportunity missed!");
        // Position of facee in app.
        overrideDefaultSettings.put(Appear2mee.kFaceHeadPosition,Appear2mee.kFaceHeadTopRight);
        overrideDefaultSettings.put(Appear2mee.kFaceShouldersPosition,Appear2mee.kFaceShouldersRight);

        // Color of face background, only used with Appear2mee.kFaceHeadCenter setting for Appear2mee.kFaceHeadPosition:
        overrideDefaultSettings.put(Appear2mee.kFaceCenterBackgroundColor,  Appear2mee.colorToString(Color.WHITE));

        //Color of app dialog background (for rich texts only)
        overrideDefaultSettings.put(Appear2mee.kDisplayBackgroundColor, Appear2mee.colorToString(Color.argb((int)(0.6*255),0,0,0)));
        overrideDefaultSettings.put(Appear2mee.kFaceDisplayBackgroundColor,  Appear2mee.colorToString(Color.argb((int)(0.6*255),0,0,0)));
      //  overrideDefaultSettings.put(Appear2mee.kFaceNotificationSound, String.format(Locale.US,"%d",R.raw.appear2meefacesound));
        overrideDefaultSettings.put(Appear2mee.kFaceAlertDismissTime,String.format(Locale.US,"%f",5.0));

        //overrideDefaultSettings.put(Appear2mee.kLocationRationalMessage,
        //        "Location Services are needed to send you notifications that are relevant to your current position.");
        //overrideDefaultSettings.put(Appear2mee.kOpenExternalURLAutomatically,"true");
        Appear2mee.defaultSettings(overrideDefaultSettings); // This merges your settings with existing settings.
    }

    @Override
    public Appear2mee.ResponseListener appear2meeResponseListener(Bundle payload) {
        final String wasMessage = payload.getString("userData");
        if(wasMessage != null) {
            return new Appear2mee.ResponseListener() {
                @Override
                public void acceptAction(Map<String, String> keyValueDict) {
                    Toast.makeText(getApplicationContext() , String.format(Locale.US,"userData:%s key/values %s",wasMessage,keyValueDict.toString()), Toast.LENGTH_LONG).show();
                }

                @Override
                public void dismissAction(Map<String, String> keyValueDict) {
                    Toast.makeText(getApplicationContext() , String.format(Locale.US,"userData:%s Dismissed",wasMessage), Toast.LENGTH_LONG).show();
                }
            };
        }
        return new Appear2mee.ResponseListener() {
            @Override
            public void acceptAction(Map<String, String> keyValueDict) {
                Toast.makeText(getApplicationContext() , String.format("key/values %s",keyValueDict.toString()), Toast.LENGTH_LONG).show();
            }

            @Override
            public void dismissAction(Map<String, String> keyValueDict) {
                Toast.makeText(getApplicationContext() , "Dismissed", Toast.LENGTH_LONG).show();
            }
        };
    }

}
